﻿<%@ Page Language="C#" AutoEventWireup="true"  CodeFile="Default.aspx.cs" Inherits="_Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
    <title>Google 3-d Map</title>
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.5/jquery.min.js"></script>
    <script src="https://www.google.com/jsapi?key=your google map api key"></script> 
    <script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>    
    <script type="text/javascript">
         var ge; //hold instance of google earth plugin
         var model; // hold 3d model to be placed on earth
         var marker; //hold marker on the google map
         var map; //hold instance of google map
         
         google.load("earth", "1.5");
         google.setOnLoadCallback(init);
         
         function init() {
             google.earth.createInstance('div_map3d', initialise3dMap, failed);
         }
         
         function failed(errorCode) { alert('Unable to load google earth ' + errorCode); }

         function initialise3dMap(instance) {
             //initialise google earth plugin instance for the very first time.
             ge = instance;
             ge.getWindow().setVisibility(true);
             ge.getOptions().setStatusBarVisibility(true);
             ge.getLayerRoot().enableLayerById(ge.LAYER_BUILDINGS, true);
             ge.getLayerRoot().enableLayerById(ge.LAYER_TERRAIN, true);
             ge.getOptions().setFlyToSpeed(1);             
             
             var lookAt = ge.createLookAt('');  // Create a new LookAt (i.e point where we are looking )
             lookAt.setLatitude(-37.825307);    // Set the coordinates values of the point where we looking at.
             lookAt.setLongitude(144.980183);
             lookAt.setRange(100);
             lookAt.setAltitudeMode(ge.ALTITUDE_RELATIVE_TO_GROUND);            // Set zoom range i.e from how far are we looking at the point.
             lookAt.setAltitude(0);             // Set altitude from ground of the point where we looking at.
             lookAt.setTilt(45);                // Set the tilt angle where we looking at i.e how many degrees we need to down our head to look at the point.
             ge.getView().setAbstractView(lookAt);
             
             // 3D Model placement
             model = ge.createModel('');            // create the model geometry             
             var loc = ge.createLocation('');       
             var scale = ge.createScale('');        
             var orientation = ge.CreateOrientation(''); 
             loc.setLatitude(lookAt.getLatitude()); // fetch location of the current lookat point.
             loc.setLongitude(lookAt.getLongitude());
             loc.setAltitude(0);
             model.setAltitudeMode(ge.ALTITUDE_RELATIVE_TO_GROUND);
             model.setLocation(loc);                // set the location of the model.
             scale.Set(2, 2, 2);                    
             model.setScale(scale);                 // set scale fo the model along x,y,z axis
             orientation.setHeading(-180);          
             model.setOrientation(orientation);     // rotate the model x degrees from north.             
             var link = ge.createLink('');          // defining link
             model.setLink(link);                   // setting the collada file for the model
             //**********host your collada file somewhere and set the link to .dae file below********//
             link.setHref('http://www.yourdomain.com/Model3d/models/us_police_car.dae');              
             var modelPlacemark = ge.createPlacemark('');   // define the model placemark 
             modelPlacemark.setGeometry(model);             // set model in to the placemark
             ge.getFeatures().appendChild(modelPlacemark); // add placemark to Earth  
         }

         function initialise2dMap() {
             var latlng = new google.maps.LatLng(-37.825307, 144.980183);
             var myOptions = {
                 zoom: 15,
                 panControl: false,
                 streetViewControl: false,                
                 center: latlng,
                 mapTypeId: google.maps.MapTypeId.SATELLITE
             };
             map = new google.maps.Map(document.getElementById("div_map2d"), myOptions);
             marker = new google.maps.Marker({ map: map, draggable: true, animation: google.maps.Animation.DROP, position: latlng });
         }

         function onresize() {
             var clientHeight = document.documentElement.clientHeight;
             $('#holder').each(function() {
                 $(this).css({
                     height: (clientHeight - $(this).position().top-50).toString() + 'px'
                 });
             });
         }

         $(window).resize(onresize);
         onresize();

         function enbalebuildings() {
         if(buildings.checked)
             ge.getLayerRoot().enableLayerById(ge.LAYER_BUILDINGS, true);
            else
                ge.getLayerRoot().enableLayerById(ge.LAYER_BUILDINGS, false);
        }

        function toggle2d() {
            if (show2d.value == "Show 2-D Map") {
                $("#td2dmap").animate({ width: "50%" }, 500);
                $("#td3dmap").animate({ width: "50%" }, 500);
                show2d.value = "Hide 2-D Map";
            }
            else {
                $("#td2dmap").animate({ width: "0%" }, 500);
                $("#td3dmap").animate({ width: "100%" }, 500);
                show2d.value = "Show 2-D Map";
            }
        }       
         
         $(window).load(function() {
            initialise2dMap();
        });

        var plat =0, plon =0; // previous latitude and longitude
        function MoveTo(lat, lon) {
            if (plat != lat || plon != lon) { // if new location is not same as previous location
                var lookAt = ge.getView().copyAsLookAt(ge.ALTITUDE_RELATIVE_TO_GROUND); // get current lookAt view
                lat1 = lookAt.getLatitude();
                lon1 = lookAt.getLongitude();
                lat2 = lat;
                lon2 = lon;
                var br = GetDirection(lat1, lon1, lat2, lon2); // get heading direction from previous location to current location (x degrees from north)
                lookAt.setHeading(br);      // set this as a new heading diretion.
                lookAt.setLatitude(lat);    // set new location
                lookAt.setLongitude(lon);
                lookAt.setRange(100);
                ge.getView().setAbstractView(lookAt);   // update google earth to this new location
                
                model.getLocation().setLatLngAlt(lat, lon, 0);  // get 3d model location and update it to new location
                var orientation = ge.CreateOrientation('');
                orientation.setHeading(br - 180);   // set model orientation to the same heading direction (x dgrees from noth)
                model.setOrientation(orientation);

                var position = new google.maps.LatLng(lat, lon);    // move the 2d map marker to the new location
                marker.setPosition(position);
                map.setCenter(position);    // set this new location as the center of the map
            }            
            plat = lat; plon = lon; //make current location as previous location before leaving.
        }
        
        function MoveToLatest() {
            var currentTime = new Date();
            var vodid = $("#<%= HiddenVodId.ClientID %>").val();
            // calling rest web service
            $.getJSON('/website/RESTfulService.svc/LiveLocation/json?' + currentTime.getTime(), function(data) {
                MoveTo(data.lat, data.lon);
            });
        }
        
        var interval = 0;
        function startTracking() {
            interval = setInterval("MoveToLatest()", 500); // call moveToLatest in every 300 ms
        }
                    
        function stopTracking() {
            clearInterval(interval);
        }
        
        function GetDirection(lat1, lon1, lat2, lon2) {
            var br = 0;
            br = Math.atan2(Math.sin(lon2 - lon1) * Math.cos(lat2), Math.cos(lat1) * Math.sin(lat2) - Math.sin(lat1) * Math.cos(lat2) * Math.cos(lon2 - lon1)) % (2 * Math.PI);
            br = (br * 180) / Math.PI;
            return br;
        }

     </script> 
</head>
<body style="margin:0px; background-color:Orange"> 
    
        <table id="holder" style="height:700px; width:100%; border-collapse:collapse" cellspacing="0" cellpadding="1" >
        <tr>
        <td colspan="2" style="height:30px;"> <div style=" background-color:Gray; color:white">
        <input type="checkbox" id="buildings" title="Toggle 3-D Buildings" checked="checked" onclick="enbalebuildings()" />3-D Buildings &nbsp;|&nbsp;
        <input type="button" id="show2d" title="Toggle 3-D Buildings" onclick="toggle2d()" value="Hide 2-D Map" />  
        <input type="button" id="Button1" title="Toggle 3-D Buildings" onclick="startTracking()" value="start" />    
        <input type="button" id="Button3" title="Toggle 3-D Buildings" onclick="stopTracking()" value="stop" />  
        </div></td>
        </tr>
        <tr>
            <td id="td3dmap" style="height:100%; width:50%"><div id="div_map3d" style="height:100%; width:100%;"></div></td>
            <td id="td2dmap" style="height:100%; width:50%"><div id="div_map2d" style="height:100%; width:100%;"></div> </td>           
        </tr>
        </table>
    <form id="form1" runat="server">     
         <asp:HiddenField runat="server" ID="HiddenUserId" />
         <asp:HiddenField runat="server" ID="HiddenVodId" />
    </form>
</body>
</html>
